Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification.ConditionalEvaluation/3.3/HeuristicLabGPConditionalEvaluationPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification.ConditionalEvaluation/3.3/HeuristicLabGPConditionalEvaluationPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification.ConditionalEvaluation/3.3/HeuristicLabGPConditionalEvaluationPlugin.cs	(revision 2587)
@@ -26,13 +26,13 @@
 
 namespace HeuristicLab.GP.StructureIdentification.ConditionalEvaluation {
-  [ClassInfo(Name = "HeuristicLab.GP.StructureIdentification.ConditionalEvaluation-3.3")]
-  [PluginFile(Filename = "HeuristicLab.GP.StructureIdentification.ConditionalEvaluation-3.3.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.GP-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.StructureIdentification-3.3")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
+  [Plugin("HeuristicLab.GP.StructureIdentification.ConditionalEvaluation-3.3")]
+  [PluginFile("HeuristicLab.GP.StructureIdentification.ConditionalEvaluation-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.GP-3.3")]
+  [PluginDependency("HeuristicLab.GP.Interfaces-3.3")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification-3.3")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
   public class HeuristicLabGPConditionalEvaluationPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/HeuristicLabGPTimeSeriesPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/HeuristicLabGPTimeSeriesPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/HeuristicLabGPTimeSeriesPlugin.cs	(revision 2587)
@@ -26,16 +26,16 @@
 
 namespace HeuristicLab.GP.StructureIdentification.TimeSeries {
-  [ClassInfo(Name = "HeuristicLab.GP.StructureIdentification.TimeSeries-3.3")]
-  [PluginFile(Filename = "HeuristicLab.GP.StructureIdentification.TimeSeries-3.3.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.GP-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.StructureIdentification-3.3")]
-  [Dependency(Dependency = "HeuristicLab.Logging-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Plugin("HeuristicLab.GP.StructureIdentification.TimeSeries-3.3")]
+  [PluginFile("HeuristicLab.GP.StructureIdentification.TimeSeries-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Constraints-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.GP-3.3")]
+  [PluginDependency("HeuristicLab.GP.Interfaces-3.3")]
+  [PluginDependency("HeuristicLab.GP.StructureIdentification-3.3")]
+  [PluginDependency("HeuristicLab.Logging-3.2")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
   public class HeuristicLabGPTimeSeriesPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs	(revision 2587)
@@ -23,22 +23,22 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  [ClassInfo(Name = "HeuristicLab.GP.StructureIdentification-3.3")]
-  [PluginFile(Filename = "HeuristicLab.GP.StructureIdentification-3.3.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Evolutionary-3.2")]
-  [Dependency(Dependency = "HeuristicLab.GP-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
-  [Dependency(Dependency = "HeuristicLab.GP.Operators-3.3")]
-  [Dependency(Dependency = "HeuristicLab.Logging-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators.Programmable-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Selection-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Selection.OffspringSelection-3.2")]
-  [Dependency(Dependency = "HeuristicLab.SequentialEngine-3.2")]
+  [Plugin("HeuristicLab.GP.StructureIdentification-3.3")]
+  [PluginFile("HeuristicLab.GP.StructureIdentification-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.Evolutionary-3.2")]
+  [PluginDependency("HeuristicLab.GP-3.3")]
+  [PluginDependency("HeuristicLab.GP.Interfaces-3.3")]
+  [PluginDependency("HeuristicLab.GP.Operators-3.3")]
+  [PluginDependency("HeuristicLab.Logging-3.2")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
+  [PluginDependency("HeuristicLab.Operators.Programmable-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
+  [PluginDependency("HeuristicLab.Selection-3.2")]
+  [PluginDependency("HeuristicLab.Selection.OffspringSelection-3.2")]
+  [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
   public class HeuristicLabGPStructureIdentificationPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.GP/3.3/FunctionTreeView.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.GP/3.3/FunctionTreeView.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.GP/3.3/FunctionTreeView.cs	(revision 2587)
@@ -47,7 +47,5 @@
       rootNode.Tag = functionTree;
       treeNodeContextMenu.MenuItems.Clear();
-      DiscoveryService discoveryService = new DiscoveryService();
-      IFunctionTreeSerializer[] exporters = discoveryService.GetInstances<IFunctionTreeSerializer>();
-      foreach (IFunctionTreeSerializer exporter in exporters) {
+      foreach (IFunctionTreeSerializer exporter in ApplicationManager.Manager.GetInstances<IFunctionTreeSerializer>()) {
         string result;
         // register a menu item for the exporter
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.GP/3.3/HeuristicLabGPPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.GP/3.3/HeuristicLabGPPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.GP/3.3/HeuristicLabGPPlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.GP {
-  [ClassInfo(Name = "HeuristicLab.GP-3.3")]
-  [PluginFile(Filename = "HeuristicLab.GP-3.3.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
+  [Plugin("HeuristicLab.GP-3.3")]
+  [PluginFile("HeuristicLab.GP-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.GP.Interfaces-3.3")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
   public class HeuristicLabGPPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid.HiveBridge/3.2/HeuristicLabGridHiveBridgePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid.HiveBridge/3.2/HeuristicLabGridHiveBridgePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid.HiveBridge/3.2/HeuristicLabGridHiveBridgePlugin.cs	(revision 2587)
@@ -26,12 +26,12 @@
 
 namespace HeuristicLab.Grid.HiveBridge {
-  [ClassInfo(Name = "HeuristicLab.Grid.HiveBridge-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Grid.HiveBridge-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Grid-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.JobBase-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Engine-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Tracing-3.2")]
+  [Plugin("HeuristicLab.Grid.HiveBridge-3.2")]
+  [PluginFile("HeuristicLab.Grid.HiveBridge-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Grid-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Hive.JobBase-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Engine-3.2")]
+  [PluginDependency("HeuristicLab.Tracing-3.2")]
   public class HeuristicLabGridPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid.HiveBridge/3.2/HiveGridServerWrapper.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid.HiveBridge/3.2/HiveGridServerWrapper.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid.HiveBridge/3.2/HiveGridServerWrapper.cs	(revision 2587)
@@ -131,9 +131,8 @@
       stream.Close();
 
-      DiscoveryService service = new DiscoveryService();
-      List<PluginInfo> plugins = new List<PluginInfo>();
+      List<IPluginDescription> plugins = new List<IPluginDescription>();
 
       foreach (IStorable storeable in dictionary.Values) {
-        PluginInfo pluginInfo = service.GetDeclaringPlugin(storeable.GetType());
+        IPluginDescription pluginInfo = ApplicationManager.Manager.GetDeclaringPlugin(storeable.GetType());
         if (!plugins.Contains(pluginInfo)) {
           plugins.Add(pluginInfo);
@@ -144,5 +143,5 @@
       }
 
-      foreach (PluginInfo uniquePlugin in plugins) {
+      foreach (IPluginDescription uniquePlugin in plugins) {
         HivePluginInfo pluginInfo =
           new HivePluginInfo();
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridClient.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridClient.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridClient.cs	(revision 2587)
@@ -134,5 +134,5 @@
         if(gotEngine && !stopped) {
           executing = true;
-          AppDomain engineDomain = PluginManager.Manager.CreateAndInitAppDomain("Engine domain");
+          AppDomain engineDomain = HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox("Engine domain");
           Type engineRunnerType = typeof(EngineRunner);
           
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridClientApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridClientApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridClientApplication.cs	(revision 2587)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Grid {
-  [ClassInfo(Name = "Grid Client", Description="Client application for the distributed engine grid.", AutoRestart = true)]
+  [Application("Grid Client", "Client application for the distributed engine grid.", true)]
   class GridClientApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridServerApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridServerApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/GridServerApplication.cs	(revision 2587)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Grid {
-  [ClassInfo(Name = "Grid Server", Description = "Server application for the distributed engine grid.", AutoRestart=true)]
+  [Application("Grid Server", "Server application for the distributed engine grid.", true)]
   class GridServerApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/HeuristicLabGridPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/HeuristicLabGridPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Grid/3.2/HeuristicLabGridPlugin.cs	(revision 2587)
@@ -27,8 +27,8 @@
 
 namespace HeuristicLab.Grid {
-  [ClassInfo(Name = "HeuristicLab.Grid-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Grid-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Tracing-3.2")]
+  [Plugin("HeuristicLab.Grid-3.2")]
+  [PluginFile("HeuristicLab.Grid-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Tracing-3.2")]
   public class HeuristicLabGridPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Common/3.2/CommonPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Common/3.2/CommonPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Common/3.2/CommonPlugin.cs	(revision 2587)
@@ -27,9 +27,9 @@
 
 namespace HeuristicLab.Hive.Client.Common {
-  [ClassInfo(Name = "HeuristicLab.Hive.Client.Common-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Client.Common-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Tracing-3.2")]
+  [Plugin("HeuristicLab.Hive.Client.Common-3.2")]
+  [PluginFile("HeuristicLab.Hive.Client.Common-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Tracing-3.2")]
   public class CommonPlugin: PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Communication/3.2/CommunicationsPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Communication/3.2/CommunicationsPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Communication/3.2/CommunicationsPlugin.cs	(revision 2587)
@@ -29,10 +29,10 @@
 namespace HeuristicLab.Hive.Client.Communication {
   
-  [ClassInfo(Name = "HeuristicLab.Hive.Client.Communication-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Client.Communication-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAccess-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Client.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
+  [Plugin("HeuristicLab.Hive.Client.Communication-3.2")]
+  [PluginFile("HeuristicLab.Hive.Client.Communication-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.DataAccess-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Client.Common-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
   public class CommunicationsPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsoleApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsoleApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsoleApplication.cs	(revision 2587)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Hive.Client.Console {
-  [ClassInfo(Name = "Hive Client Console", Description = "Console Application for the Hive Client.", AutoRestart = false)]
+  [Application("Hive Client Console", "Console Application for the Hive Client.", false)]
   class HiveClientConsoleApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsolePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsolePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Console/3.2/HiveClientConsolePlugin.cs	(revision 2587)
@@ -27,8 +27,8 @@
 
 namespace HeuristicLab.Grid {
-  [ClassInfo(Name = "HeuristicLab.Hive.Client.Console-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Client.Console-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
+  [Plugin("HeuristicLab.Hive.Client.Console-3.2")]
+  [PluginFile("HeuristicLab.Hive.Client.Console-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
   public class HeuristicLabHiveClientConsolePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/ClientConsoleService/ClientConsoleServer.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/ClientConsoleService/ClientConsoleServer.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/ClientConsoleService/ClientConsoleServer.cs	(revision 2587)
@@ -12,6 +12,4 @@
   public class ClientConsoleServer {
 
-    DiscoveryService discService = new DiscoveryService();
-   
     private bool AddMexEndpoint(ServiceHost serviceHost) {
       if (serviceHost != null) {
@@ -29,10 +27,10 @@
     
     public ServiceHost StartClientConsoleServer(Uri uriTcp) {
-      IClientConsoleCommunicator[] clientConsoleServerInstances =
-        discService.GetInstances<IClientConsoleCommunicator>();
+      IEnumerable<IClientConsoleCommunicator> clientConsoleServerInstances =
+        ApplicationManager.Manager.GetInstances<IClientConsoleCommunicator>();
 
-      if (clientConsoleServerInstances.Length > 0) {
+      if (clientConsoleServerInstances.Count() > 0) {
         ServiceHost serviceHost =
-                new ServiceHost(clientConsoleServerInstances[0].GetType(),
+                new ServiceHost(clientConsoleServerInstances.First().GetType(),
                   uriTcp);
 
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/Core.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 2587)
@@ -49,5 +49,5 @@
   /// The core component of the Hive Client
   /// </summary>
-  public class Core: MarshalByRefObject {       
+  public class Core : MarshalByRefObject {
     public static bool abortRequested { get; set; }
     private bool currentlyFetching = false;
@@ -59,11 +59,10 @@
     private WcfService wcfService;
     private Heartbeat beat;
-    
+
     /// <summary>
     /// Main Method for the client
     /// </summary>
-    public void Start() {      
+    public void Start() {
       abortRequested = false;
-      PluginManager.Manager.Initialize();
       Logging.Instance.Info(this.ToString(), "Hive Client started");
       ClientConsoleServer server = new ClientConsoleServer();
@@ -74,5 +73,5 @@
 
 
-      
+
       //Register all Wcf Service references
       wcfService = WcfService.Instance;
@@ -85,5 +84,5 @@
       wcfService.Connected += new EventHandler(wcfService_Connected);
       //Recover Server IP and Port from the Settings Framework
-      ConnectionContainer cc = ConfigManager.Instance.GetServerIPAndPort();     
+      ConnectionContainer cc = ConfigManager.Instance.GetServerIPAndPort();
       if (cc.IPAdress != String.Empty && cc.Port != 0)
         wcfService.SetIPAndPort(cc.IPAdress, cc.Port);
@@ -91,11 +90,11 @@
       if (UptimeManager.Instance.isOnline())
         wcfService.Connect();
-         
+
       //Initialize the heartbeat
       beat = new Heartbeat { Interval = 10000 };
-      beat.StartHeartbeat();     
+      beat.StartHeartbeat();
 
       MessageQueue queue = MessageQueue.GetInstance();
-      
+
       //Main processing loop     
       //Todo: own thread for message handling
@@ -108,5 +107,5 @@
       }
       Console.WriteLine("ended!");
-    }    
+    }
 
     /// <summary>
@@ -114,9 +113,9 @@
     /// </summary>
     /// <param name="container">The Container, containing the message</param>
-    private void DetermineAction(MessageContainer container) {           
+    private void DetermineAction(MessageContainer container) {
       switch (container.Message) {
         //Server requests to abort a job
         case MessageContainer.MessageType.AbortJob:
-          if(engines.ContainsKey(container.JobId))
+          if (engines.ContainsKey(container.JobId))
             engines[container.JobId].Abort();
           else
@@ -126,10 +125,10 @@
 
 
-        case MessageContainer.MessageType.JobAborted:          
-        //todo: thread this
+        case MessageContainer.MessageType.JobAborted:
+          //todo: thread this
           Debug.WriteLine("Job aborted, he's dead");
-          lock (engines) {            
+          lock (engines) {
             Guid jobId = new Guid(container.JobId.ToString());
-            if(engines.ContainsKey(jobId)) {
+            if (engines.ContainsKey(jobId)) {
               appDomains[jobId].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
               AppDomain.Unload(appDomains[jobId]);
@@ -142,21 +141,21 @@
           }
           break;
-        
-        
+
+
         //Request a Snapshot from the Execution Engine
         case MessageContainer.MessageType.RequestSnapshot:
-          if (engines.ContainsKey(container.JobId)) 
+          if (engines.ContainsKey(container.JobId))
             engines[container.JobId].RequestSnapshot();
           else
             Logging.Instance.Error(this.ToString(), "RequestSnapshot: Engine doesn't exist");
           break;
-        
-        
+
+
         //Snapshot is ready and can be sent back to the Server
         case MessageContainer.MessageType.SnapshotReady:
-          ThreadPool.QueueUserWorkItem(new WaitCallback(GetSnapshot), container.JobId);          
-          break;
-        
-        
+          ThreadPool.QueueUserWorkItem(new WaitCallback(GetSnapshot), container.JobId);
+          break;
+
+
         //Pull a Job from the Server
         case MessageContainer.MessageType.FetchJob:
@@ -164,13 +163,13 @@
             wcfService.SendJobAsync(ConfigManager.Instance.GetClientInfo().Id);
             currentlyFetching = true;
-          }          
-          break;          
-        
-        
+          }
+          break;
+
+
         //A Job has finished and can be sent back to the server
         case MessageContainer.MessageType.FinishedJob:
-          ThreadPool.QueueUserWorkItem(new WaitCallback(GetFinishedJob), container.JobId);          
-          break;     
-        
+          ThreadPool.QueueUserWorkItem(new WaitCallback(GetFinishedJob), container.JobId);
+          break;
+
 
         //When the timeslice is up
@@ -186,5 +185,5 @@
               kvp.Value.RequestSnapshot();
             }
-            
+
           } else {
             //Disconnect afterwards
@@ -192,6 +191,6 @@
           }
           break;
-        
-        
+
+
         //Hard shutdown of the client
         case MessageContainer.MessageType.Shutdown:
@@ -211,5 +210,5 @@
     //Asynchronous Threads for interaction with the Execution Engine
     #region Async Threads for the EE
-    
+
     /// <summary>
     /// serializes the finished job and submits it to the server. If, at the time, a network connection is unavailable, the Job gets stored on the disk. 
@@ -218,5 +217,5 @@
     /// <param name="jobId"></param>
     private void GetFinishedJob(object jobId) {
-      Guid jId = (Guid)jobId;      
+      Guid jId = (Guid)jobId;
       try {
         if (!engines.ContainsKey(jId)) {
@@ -224,5 +223,5 @@
           return;
         }
-        
+
         byte[] sJob = engines[jId].GetFinishedJob();
 
@@ -261,9 +260,9 @@
       //Uptime Limit reached, now is a good time to destroy this jobs.
       if (!UptimeManager.Instance.isOnline()) {
-        KillAppDomain(jId);        
+        KillAppDomain(jId);
         //Still anything running?
         if (engines.Count == 0)
           WcfService.Instance.Disconnect();
-      
+
       } else {
         engines[jId].StartOnlyJob();
@@ -283,8 +282,8 @@
       if (e.Result.Success) {
         currentlyFetching = false;
-        Logging.Instance.Info(this.ToString(), "Login completed to Hive Server @ " + DateTime.Now);        
+        Logging.Instance.Info(this.ToString(), "Login completed to Hive Server @ " + DateTime.Now);
       } else
         Logging.Instance.Error(this.ToString(), e.Result.StatusMessage);
-    }    
+    }
 
     /// <summary>
@@ -294,11 +293,10 @@
     /// <param name="e"></param>
     void wcfService_SendJobCompleted(object sender, SendJobCompletedEventArgs e) {
-      if (e.Result.StatusMessage != ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT) {        
-        bool sandboxed = false;
+      if (e.Result.StatusMessage != ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT) {
         List<byte[]> files = new List<byte[]>();
         foreach (CachedHivePluginInfo plugininfo in PluginCache.Instance.GetPlugins(e.Result.Job.PluginsNeeded))
           files.AddRange(plugininfo.PluginFiles);
 
-        AppDomain appDomain = PluginManager.Manager.CreateAndInitAppDomainWithSandbox(e.Result.Job.Id.ToString(), sandboxed, null, files);
+        AppDomain appDomain = HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox(e.Result.Job.Id.ToString(), files);
         appDomain.UnhandledException += new UnhandledExceptionEventHandler(appDomain_UnhandledException);
         lock (engines) {
@@ -309,5 +307,5 @@
             Executor engine = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
             engine.JobId = e.Result.Job.Id;
-            engine.Queue = MessageQueue.GetInstance();            
+            engine.Queue = MessageQueue.GetInstance();
             engine.Start(e.Data);
             engines.Add(e.Result.Job.Id, engine);
@@ -317,5 +315,5 @@
             Debug.WriteLine("Increment FetchedJobs to:" + ClientStatusInfo.JobsFetched);
           }
-        }        
+        }
       }
       currentlyFetching = false;
@@ -329,8 +327,8 @@
     void wcfService_StoreFinishedJobResultCompleted(object sender, StoreFinishedJobResultCompletedEventArgs e) {
       KillAppDomain(e.Result.JobId);
-      if (e.Result.Success) {            
+      if (e.Result.Success) {
         ClientStatusInfo.JobsProcessed++;
-        Debug.WriteLine("ProcessedJobs to:" + ClientStatusInfo.JobsProcessed);                
-      } else {        
+        Debug.WriteLine("ProcessedJobs to:" + ClientStatusInfo.JobsProcessed);
+      } else {
         Logging.Instance.Error(this.ToString(), "Sending of job " + e.Result.JobId + " failed, job has been wasted. Message: " + e.Result.StatusMessage);
       }
@@ -371,5 +369,5 @@
     /// <param name="e"></param>
     void wcfService_Connected(object sender, EventArgs e) {
-      wcfService.LoginSync(ConfigManager.Instance.GetClientInfo());      
+      wcfService.LoginSync(ConfigManager.Instance.GetClientInfo());
       JobStorageManager.CheckAndSubmitJobsFromDisc();
       currentlyFetching = false;
@@ -378,5 +376,5 @@
     //this is a little bit tricky - 
     void wcfService_ConnectionRestored(object sender, EventArgs e) {
-      Logging.Instance.Info(this.ToString(), "Reconnected to old server - checking currently running appdomains");                 
+      Logging.Instance.Info(this.ToString(), "Reconnected to old server - checking currently running appdomains");
 
       foreach (KeyValuePair<Guid, Executor> execKVP in engines) {
@@ -396,8 +394,8 @@
 
     void appDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e) {
-      Logging.Instance.Error(this.ToString(), "Exception in AppDomain: " + e.ExceptionObject.ToString());      
-    }
-
-    internal Dictionary<Guid, Job> GetJobs() {           
+      Logging.Instance.Error(this.ToString(), "Exception in AppDomain: " + e.ExceptionObject.ToString());
+    }
+
+    internal Dictionary<Guid, Job> GetJobs() {
       return jobs;
     }
@@ -415,5 +413,5 @@
           engines.Remove(id);
           jobs.Remove(id);
-        }        
+        }
         catch (Exception ex) {
           Logging.Instance.Error(this.ToString(), "Exception when unloading the appdomain: ", ex);
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/CoreApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/CoreApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/CoreApplication.cs	(revision 2587)
@@ -31,6 +31,6 @@
 
 namespace HeuristicLab.Hive.Client.Core {
-  [ClassInfo(Name = "Hive Client", Description = "Hive Client Core baseclass", AutoRestart = false)]
-  public class CoreApplication: ApplicationBase {
+  [Application("Hive Client", "Hive Client Core baseclass", false)]
+  public class CoreApplication : ApplicationBase {
     public override void Run() {
       Core core = new Core();
